# coding: utf-8

"""
    Voucherify API

    Voucherify promotion engine REST API. Please see https://docs.voucherify.io/docs for more details.

    The version of the OpenAPI document: v2018-08-01
    Contact: support@voucherify.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from voucherify.models.customer_redeemable_redeemable import CustomerRedeemableRedeemable
from typing import Optional, Set
from typing_extensions import Self

class CustomerRedeemable(BaseModel):
    """
    Single customer's redeemable
    """ # noqa: E501
    id: Optional[StrictStr] = Field(default=None, description="Unique redeemable holder identifier.")
    created_at: Optional[datetime] = Field(default=None, description="Timestamp representing the date and time when the redeemable was assigned. The value is shown in the ISO 8601 format.")
    redeemable_id: Optional[StrictStr] = Field(default=None, description="Identifier of the redeemable item.")
    redeemable_object: Optional[StrictStr] = Field(default=None, description="Type of the redeemable.")
    customer_id: Optional[StrictStr] = Field(default=None, description="Identifier of the customer.")
    holder_role: Optional[StrictStr] = Field(default='OWNER', description="Role of the holder.")
    campaign_id: Optional[StrictStr] = Field(default=None, description="Unique campaign identifier, assigned by Voucherify.")
    campaign_type: Optional[StrictStr] = Field(default='DISCOUNT_COUPONS', description="Defines the type of the campaign.")
    voucher_type: Optional[StrictStr] = Field(default='DISCOUNT_VOUCHER', description="Defines the type of the voucher.")
    redeemable: Optional[CustomerRedeemableRedeemable] = None
    __properties: ClassVar[List[str]] = ["id", "created_at", "redeemable_id", "redeemable_object", "customer_id", "holder_role", "campaign_id", "campaign_type", "voucher_type", "redeemable"]

    @field_validator('holder_role')
    def holder_role_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['OWNER', 'REFERRER', 'REFEREE']):
            raise ValueError("must be one of enum values ('OWNER', 'REFERRER', 'REFEREE')")
        return value

    @field_validator('campaign_type')
    def campaign_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['LOYALTY_PROGRAM', 'GIFT_VOUCHERS', 'DISCOUNT_COUPONS', 'PROMOTION', 'REFERRAL_PROGRAM', 'LUCKY_DRAW']):
            raise ValueError("must be one of enum values ('LOYALTY_PROGRAM', 'GIFT_VOUCHERS', 'DISCOUNT_COUPONS', 'PROMOTION', 'REFERRAL_PROGRAM', 'LUCKY_DRAW')")
        return value

    @field_validator('voucher_type')
    def voucher_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['GIFT_VOUCHER', 'DISCOUNT_VOUCHER', 'LOYALTY_CARD', 'LUCKY_DRAW_CODE']):
            raise ValueError("must be one of enum values ('GIFT_VOUCHER', 'DISCOUNT_VOUCHER', 'LOYALTY_CARD', 'LUCKY_DRAW_CODE')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CustomerRedeemable from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of redeemable
        if self.redeemable:
            _dict['redeemable'] = self.redeemable.to_dict()
        # set to None if id (nullable) is None
        # and model_fields_set contains the field
        if self.id is None and "id" in self.model_fields_set:
            _dict['id'] = None

        # set to None if created_at (nullable) is None
        # and model_fields_set contains the field
        if self.created_at is None and "created_at" in self.model_fields_set:
            _dict['created_at'] = None

        # set to None if redeemable_id (nullable) is None
        # and model_fields_set contains the field
        if self.redeemable_id is None and "redeemable_id" in self.model_fields_set:
            _dict['redeemable_id'] = None

        # set to None if redeemable_object (nullable) is None
        # and model_fields_set contains the field
        if self.redeemable_object is None and "redeemable_object" in self.model_fields_set:
            _dict['redeemable_object'] = None

        # set to None if customer_id (nullable) is None
        # and model_fields_set contains the field
        if self.customer_id is None and "customer_id" in self.model_fields_set:
            _dict['customer_id'] = None

        # set to None if holder_role (nullable) is None
        # and model_fields_set contains the field
        if self.holder_role is None and "holder_role" in self.model_fields_set:
            _dict['holder_role'] = None

        # set to None if campaign_id (nullable) is None
        # and model_fields_set contains the field
        if self.campaign_id is None and "campaign_id" in self.model_fields_set:
            _dict['campaign_id'] = None

        # set to None if campaign_type (nullable) is None
        # and model_fields_set contains the field
        if self.campaign_type is None and "campaign_type" in self.model_fields_set:
            _dict['campaign_type'] = None

        # set to None if voucher_type (nullable) is None
        # and model_fields_set contains the field
        if self.voucher_type is None and "voucher_type" in self.model_fields_set:
            _dict['voucher_type'] = None

        # set to None if redeemable (nullable) is None
        # and model_fields_set contains the field
        if self.redeemable is None and "redeemable" in self.model_fields_set:
            _dict['redeemable'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CustomerRedeemable from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "created_at": obj.get("created_at"),
            "redeemable_id": obj.get("redeemable_id"),
            "redeemable_object": obj.get("redeemable_object"),
            "customer_id": obj.get("customer_id"),
            "holder_role": obj.get("holder_role") if obj.get("holder_role") is not None else 'OWNER',
            "campaign_id": obj.get("campaign_id"),
            "campaign_type": obj.get("campaign_type") if obj.get("campaign_type") is not None else 'DISCOUNT_COUPONS',
            "voucher_type": obj.get("voucher_type") if obj.get("voucher_type") is not None else 'DISCOUNT_VOUCHER',
            "redeemable": CustomerRedeemableRedeemable.from_dict(obj["redeemable"]) if obj.get("redeemable") is not None else None
        })
        return _obj


