# coding: utf-8

"""
    Voucherify API

    Voucherify promotion engine REST API. Please see https://docs.voucherify.io/docs for more details.

    The version of the OpenAPI document: v2018-08-01
    Contact: support@voucherify.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class CustomerSummaryOrders(BaseModel):
    """
    CustomerSummaryOrders
    """ # noqa: E501
    total_amount: Optional[StrictInt] = Field(default=None, description="The total amount spent by the customer. Value is multiplied by 100 to precisely represent 2 decimal places. For example `10000 cents` for `$100.00`.")
    total_count: Optional[StrictInt] = Field(default=None, description="Total number of orders made by the customer.")
    average_amount: Optional[StrictInt] = Field(default=None, description="Average amount spent on orders. `total_amount` &divide; `total_count`. Value is multiplied by 100 to precisely represent 2 decimal places. For example `10000 cents` for `$100.00`.")
    last_order_amount: Optional[StrictInt] = Field(default=None, description="Amount spent on last order. Value is multiplied by 100 to precisely represent 2 decimal places. For example `10000 cents` for `$100.00`.")
    last_order_date: Optional[datetime] = Field(default=None, description="Timestamp representing the date and time of the customer's last order in ISO 8601 format.")
    __properties: ClassVar[List[str]] = ["total_amount", "total_count", "average_amount", "last_order_amount", "last_order_date"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CustomerSummaryOrders from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if total_amount (nullable) is None
        # and model_fields_set contains the field
        if self.total_amount is None and "total_amount" in self.model_fields_set:
            _dict['total_amount'] = None

        # set to None if total_count (nullable) is None
        # and model_fields_set contains the field
        if self.total_count is None and "total_count" in self.model_fields_set:
            _dict['total_count'] = None

        # set to None if average_amount (nullable) is None
        # and model_fields_set contains the field
        if self.average_amount is None and "average_amount" in self.model_fields_set:
            _dict['average_amount'] = None

        # set to None if last_order_amount (nullable) is None
        # and model_fields_set contains the field
        if self.last_order_amount is None and "last_order_amount" in self.model_fields_set:
            _dict['last_order_amount'] = None

        # set to None if last_order_date (nullable) is None
        # and model_fields_set contains the field
        if self.last_order_date is None and "last_order_date" in self.model_fields_set:
            _dict['last_order_date'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CustomerSummaryOrders from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "total_amount": obj.get("total_amount"),
            "total_count": obj.get("total_count"),
            "average_amount": obj.get("average_amount"),
            "last_order_amount": obj.get("last_order_amount"),
            "last_order_date": obj.get("last_order_date")
        })
        return _obj


