# coding: utf-8

"""
    Voucherify API

    Voucherify promotion engine REST API. Please see https://docs.voucherify.io/docs for more details.

    The version of the OpenAPI document: v2018-08-01
    Contact: support@voucherify.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Union
from voucherify.models.simple_product_discount_unit import SimpleProductDiscountUnit
from voucherify.models.simple_sku_discount_unit import SimpleSkuDiscountUnit
from typing import Optional, Set
from typing_extensions import Self

class DiscountUnitMultipleOneUnit(BaseModel):
    """
    DiscountUnitMultipleOneUnit
    """ # noqa: E501
    unit_off: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Number of units to be granted a full value discount.")
    unit_off_formula: Optional[StrictStr] = None
    effect: Optional[StrictStr] = Field(default=None, description="Defines how the unit is added to the customer's order.  ")
    unit_type: Optional[StrictStr] = Field(default=None, description="The product deemed as free, chosen from product inventory (e.g. time, items).")
    product: Optional[SimpleProductDiscountUnit] = None
    sku: Optional[SimpleSkuDiscountUnit] = None
    __properties: ClassVar[List[str]] = ["unit_off", "unit_off_formula", "effect", "unit_type", "product", "sku"]

    @field_validator('effect')
    def effect_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['ADD_NEW_ITEMS', 'ADD_MISSING_ITEMS']):
            raise ValueError("must be one of enum values ('ADD_NEW_ITEMS', 'ADD_MISSING_ITEMS')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DiscountUnitMultipleOneUnit from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of product
        if self.product:
            _dict['product'] = self.product.to_dict()
        # override the default output from pydantic by calling `to_dict()` of sku
        if self.sku:
            _dict['sku'] = self.sku.to_dict()
        # set to None if unit_off (nullable) is None
        # and model_fields_set contains the field
        if self.unit_off is None and "unit_off" in self.model_fields_set:
            _dict['unit_off'] = None

        # set to None if unit_off_formula (nullable) is None
        # and model_fields_set contains the field
        if self.unit_off_formula is None and "unit_off_formula" in self.model_fields_set:
            _dict['unit_off_formula'] = None

        # set to None if effect (nullable) is None
        # and model_fields_set contains the field
        if self.effect is None and "effect" in self.model_fields_set:
            _dict['effect'] = None

        # set to None if unit_type (nullable) is None
        # and model_fields_set contains the field
        if self.unit_type is None and "unit_type" in self.model_fields_set:
            _dict['unit_type'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DiscountUnitMultipleOneUnit from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "unit_off": obj.get("unit_off"),
            "unit_off_formula": obj.get("unit_off_formula"),
            "effect": obj.get("effect"),
            "unit_type": obj.get("unit_type"),
            "product": SimpleProductDiscountUnit.from_dict(obj["product"]) if obj.get("product") is not None else None,
            "sku": SimpleSkuDiscountUnit.from_dict(obj["sku"]) if obj.get("sku") is not None else None
        })
        return _obj


