# coding: utf-8

"""
    Voucherify API

    Voucherify promotion engine REST API. Please see https://docs.voucherify.io/docs for more details.

    The version of the OpenAPI document: v2018-08-01
    Contact: support@voucherify.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from voucherify.models.loyalties_members_points_expiration_list_response_body_data_item_bucket import LoyaltiesMembersPointsExpirationListResponseBodyDataItemBucket
from typing import Optional, Set
from typing_extensions import Self

class LoyaltiesMembersPointsExpirationListResponseBodyDataItem(BaseModel):
    """
    LoyaltiesMembersPointsExpirationListResponseBodyDataItem
    """ # noqa: E501
    id: StrictStr = Field(description="Unique loyalty points bucket ID.")
    voucher_id: StrictStr = Field(description="Unique parent loyalty card ID.")
    campaign_id: StrictStr = Field(description=" Unique parent campaign ID.")
    bucket: LoyaltiesMembersPointsExpirationListResponseBodyDataItemBucket
    created_at: datetime = Field(description="Timestamp representing the date and time when the loyalty points bucket object was created. The value is shown in the ISO 8601 format.")
    status: StrictStr = Field(description="Loyalty points bucket point status.")
    expires_at: datetime = Field(description="Date when the number of points defined in the bucket object are due to expire.")
    updated_at: Optional[datetime] = Field(default=None, description="Timestamp representing the date and time when the loyalty points bucket object was updated. The value is shown in the ISO 8601 format.")
    object: Annotated[str, Field(strict=True)] = Field(description="The type of the object represented by JSON. This object stores information about the loyalty points bucket.")
    __properties: ClassVar[List[str]] = ["id", "voucher_id", "campaign_id", "bucket", "created_at", "status", "expires_at", "updated_at", "object"]

    @field_validator('object')
    def object_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"loyalty_points_bucket", value):
            raise ValueError(r"must validate the regular expression /loyalty_points_bucket/")
        return value

    @field_validator('object')
    def object_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['loyalty_points_bucket']):
            raise ValueError("must be one of enum values ('loyalty_points_bucket')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of LoyaltiesMembersPointsExpirationListResponseBodyDataItem from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of bucket
        if self.bucket:
            _dict['bucket'] = self.bucket.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of LoyaltiesMembersPointsExpirationListResponseBodyDataItem from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "voucher_id": obj.get("voucher_id"),
            "campaign_id": obj.get("campaign_id"),
            "bucket": LoyaltiesMembersPointsExpirationListResponseBodyDataItemBucket.from_dict(obj["bucket"]) if obj.get("bucket") is not None else None,
            "created_at": obj.get("created_at"),
            "status": obj.get("status"),
            "expires_at": obj.get("expires_at"),
            "updated_at": obj.get("updated_at"),
            "object": obj.get("object") if obj.get("object") is not None else 'loyalty_points_bucket'
        })
        return _obj


