# coding: utf-8

"""
    Voucherify API

    Voucherify promotion engine REST API. Please see https://docs.voucherify.io/docs for more details.

    The version of the OpenAPI document: v2018-08-01
    Contact: support@voucherify.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict
from typing import Any, ClassVar, Dict, List, Optional
from voucherify.models.junction import Junction
from voucherify.models.loyalties_points_expiration_export_create_response_body_parameters_filters_campaign_id import LoyaltiesPointsExpirationExportCreateResponseBodyParametersFiltersCampaignId
from voucherify.models.loyalties_points_expiration_export_create_response_body_parameters_filters_voucher_id import LoyaltiesPointsExpirationExportCreateResponseBodyParametersFiltersVoucherId
from typing import Optional, Set
from typing_extensions import Self

class LoyaltiesPointsExpirationExportCreateResponseBodyParametersFilters(BaseModel):
    """
    Data filters used to narrow down the data records to be returned in the export.
    """ # noqa: E501
    junction: Optional[Junction] = None
    voucher_id: Optional[LoyaltiesPointsExpirationExportCreateResponseBodyParametersFiltersVoucherId] = None
    campaign_id: Optional[LoyaltiesPointsExpirationExportCreateResponseBodyParametersFiltersCampaignId] = None
    __properties: ClassVar[List[str]] = ["junction", "voucher_id", "campaign_id"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of LoyaltiesPointsExpirationExportCreateResponseBodyParametersFilters from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of voucher_id
        if self.voucher_id:
            _dict['voucher_id'] = self.voucher_id.to_dict()
        # override the default output from pydantic by calling `to_dict()` of campaign_id
        if self.campaign_id:
            _dict['campaign_id'] = self.campaign_id.to_dict()
        # set to None if voucher_id (nullable) is None
        # and model_fields_set contains the field
        if self.voucher_id is None and "voucher_id" in self.model_fields_set:
            _dict['voucher_id'] = None

        # set to None if campaign_id (nullable) is None
        # and model_fields_set contains the field
        if self.campaign_id is None and "campaign_id" in self.model_fields_set:
            _dict['campaign_id'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of LoyaltiesPointsExpirationExportCreateResponseBodyParametersFilters from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "junction": obj.get("junction"),
            "voucher_id": LoyaltiesPointsExpirationExportCreateResponseBodyParametersFiltersVoucherId.from_dict(obj["voucher_id"]) if obj.get("voucher_id") is not None else None,
            "campaign_id": LoyaltiesPointsExpirationExportCreateResponseBodyParametersFiltersCampaignId.from_dict(obj["campaign_id"]) if obj.get("campaign_id") is not None else None
        })
        return _obj


